% Lezione di lab TTR  -17/10/2012- Classificatori Bayesiani - Marco Cristani
close all;
clear all;
clc
% ---------------
% Esercizio 1.1
% ---------------
fprintf(' ---------------\n')
fprintf(' Esercizio 1.1\n')
fprintf(' ---------------\n')
%-- Visualizzazione campioni
mu1         =   1;
sigma1      =   2;

mu2         =   20;
sigma2      =   3;

num_s       =   500;

%fprintf('Generazione campioni Gaussiani 1D...');
Sample_set1 =   normrnd(mu1,sigma1,num_s,1);
Sample_set2 =   normrnd(mu2,sigma2,num_s,1);
%fprintf('OK.\n');

%Come fare intuitivamente a capire che sono distribuiti in modo normale?
%Con l'istogramma
[histo1]=hist(Sample_set1,32);
[histo2]=hist(Sample_set2,32);

h0=figure;
set(gcf,'name','visualizzazione istogrammi')
subplot(211); bar(histo1);
subplot(212); bar(histo2);


Data        =   [Sample_set1;Sample_set2];

%-- Plot campioni

maxData     =   max(Data);
minData     =   min(Data);


h_G1d = figure; hold on;
h_S1 = scatter(Sample_set1,zeros(num_s,1),10,'b');
h_S2 = scatter(Sample_set2,zeros(num_s,1),10,'r');



axis([minData-1,maxData+1,0,2])
set(gcf,'name','Campioni Gaussiani')
set(gca,'ytick',[]);
h_m1 = line([mu1;mu1],[0;2]); 
set(h_m1,'color',[0,0,1]);
text(mu1+0.05,1,'\mu1','color',[0,0,1])

h_m2 = line([mu2;mu2],[0;2]);
set(h_m2,'color',[1,0,0]);
text(mu2+0.05,1,'\mu2','color',[1,0,0])

h_leg = legend([h_S1(1);h_S2(1);h_m1;h_m2],{strcat('N1: \mu1=',num2str(mu1),' \sigma1=',num2str(sigma1));...
    ,strcat('N2: \mu2=',num2str(mu2),' \sigma2=',num2str(sigma2));...
    '\mu1';...
    '\mu2'});


fprintf('mu1 = %3.5f; dev-std1 =%3.5f\n',mu1,sigma1)
fprintf('mu1 = %3.5f; dev-std1 =%3.5f\n',mu2,sigma2)

%-- Stima media e varianza

pause
%fprintf('Stima media e varianza...')
est_mu1 = mean(Sample_set1);
est_sigma1 = std(Sample_set1);

est_mu2 = mean(Sample_set2);
est_sigma2 = std(Sample_set2);
%fprintf('OK.\n');


fprintf('mu1 stimata = %3.5f; dev-std1 stimata =%3.5f\n',est_mu1,est_sigma1)
fprintf('mu1 stimata = %3.5f; dev-std1 stimata =%3.5f\n',est_mu2,est_sigma2)

%-- Plot stime
set(h_G1d,'name','Campioni Gaussiani, confronto medie reali e stimate')
h_estm1 = line([est_mu1;est_mu1],[0;2]); 
set(h_estm1,'color',[0,0,1],'LineStyle','--');
text(est_mu1+0.05,1.5,'est. \mu1','color',[0,0,1])

h_estm2 = line([est_mu2;est_mu2],[0;2]);
set(h_estm2,'color',[1,0,0],'LineStyle','--');
text(est_mu2+0.05,1.5,'est. \mu2','color',[1,0,0])

delete(h_leg)

h_leg = legend([h_S1(1);h_S2(1);h_m1;h_m2;h_estm1;h_estm2],{strcat('N1: \mu1=',num2str(mu1),' \sigma1=',num2str(sigma1));...
    ,strcat('N2: \mu2=',num2str(mu2),' \sigma2=',num2str(sigma2));...
    ' \mu1';...
    ' \mu2';...
    'est. \mu1';...
    'est. \mu2'});

%-- Errore stime
%fprintf('Calcolo errore stime...');
err_mu1 = abs(est_mu1-mu1);
err_sigma1 = abs(est_sigma1-sigma1);

err_mu2 = abs(est_mu2-mu2);
err_sigma2 = abs(est_sigma2-sigma2);
%fprintf('OK \n');

fprintf('Errore mu1 = %3.5f; Errore dev-std1 =%3.5f\n',err_mu1,err_sigma1);
fprintf('Errore mu2 = %3.5f; Errore dev-std2 =%3.5f\n',err_mu2,err_sigma2);

pause

% ---------------
% Esercizio 1.2
% ---------------

% valuto la likelihood dei miei punti rispetto ad una data
% parametrizzazione Gaussiana
mu3 = 10.5;
dev_std3 = 2;

lik_ind3 = normpdf(Data,mu3,dev_std3);


h3 = figure;
scatter(Data,lik_ind3);

% la figura mi dice che mu3 e sigma3 c'azzeccano poco con i dati. Voglio
% quantificare la mia assunzione. Calcolo la likelihood.

lik_tot3 = prod(lik_ind3);
fprintf('Proba che theta_3 abbia generato i dati: %f\n',lik_tot3);

llik_tot3 = sum(log(lik_ind3));

% la likelihood risulta molto bassa... sbaglio qualcosa! provo quindi a
% valutare la likelihood che i punti siano effettivamente distribuiti
% secondo le distribuzioni che li hanno generati;


lik_ind1 = normpdf(Sample_set1,mu1,sigma1);

lik_ind2 = normpdf(Sample_set2,mu2,sigma2);

lik_tot12=[lik_ind1;lik_ind2];

llik_tot12 = sum(log(lik_tot12));

llik_tot3
llik_tot12

%%LASCIATE PERDERE QUI SOTTO
% 
% 
% fprintf(' ---------------\n')
% fprintf(' Esercizio 1.2\n')
% fprintf(' ---------------\n')
% % 1.2.1 -- Utilizzo le campionature ottenute al passo precedente
% 
% % 1.2.2 -- Likelihood
% Lik1 = normpdf(Sample_set1,mu1,sigma1);
% Lik2 = normpdf(Sample_set2,mu2,sigma2);
% figure(h_G1d)
% scatter(Sample_set1,Lik1,10,'bx');
% scatter(Sample_set2,Lik2,10,'rx');
% 
% % Completate voi le etichettature...
% pause
% % 1.2.3 -- Variabile somma
% SumS = Sample_set1+Sample_set2;
% 
% % 1.2.4 -- Visualizzazione variabile somma
% h_SumG1d = figure;
% h_Sum = scatter(SumS,zeros(num_s,1),10,'r');
% maxSumData     =   max(SumS);
% minSumData     =   min(SumS);
% axis([minSumData-1,maxSumData+1,0,2])
% 
% 
% % 1.2.5 -- Calcolo istogramma
% pause
% IstoSum = hist(SumS,10);
% h_IstoSum = figure;
% bar(IstoSum);
% set(gcf,'name','Istogramma distribuzione somma');
% 
% 
% % 1.2.6 -- Variabile somma
% est_mean_Sum = mean(SumS); %in teoria, mu = mu1 + mu2;
% est_std_Sum = std(SumS); % in teoria, std = sqrt(std1^2+std2^2);
% % Per una dimostrazione, vedasi http://www.fisica.unipg.it/~santucci/laboratorio/nuova_pagina_3.htm
% fprintf('Variabile somma: mu stimata = %3.5f; std stimata =%3.5f\n',est_mean_Sum,est_std_Sum);
% pause
% 
% % ---------------
% % Esercizio 1.3
% % ---------------
% 
% %-- 2D
% fprintf(' ---------------\n')
% fprintf(' Esercizio 1.3\n')
% fprintf(' ---------------\n')
% 
% 
% Mu1 = [3,6];
% Cov1 = [2,0;0,2];
% Sample_set2D =   mvnrnd(Mu1,Cov1,num_s);
% 
% h_G2d = figure; set(gcf,'name','Campioni Gaussiani 2D')
% scatter(Sample_set2D(:,1),Sample_set2D(:,2),10);
% 
% 
% %-- 3D
% pause
% Mu3D1 = [3,6,0];
% Cov3D1 = [2,0, 0;0,2,0;0,0,2];
% Sample_set3D =   mvnrnd(Mu3D1,Cov3D1,num_s);
% 
% h_G3d = figure; set(gcf,'name','Campioni Gaussiani 3D')
% scatter3(Sample_set3D(:,1),Sample_set3D(:,2),Sample_set3D(:,3),10);
% 
% 
% % variate le matrici di covarianza, osservatene gli autovalori e
% % autovettori con il comando eig, e osservate la rapp. grafica 
% % corrispondente
% 
% 
% 
% 
% % ---------------
% % Esercizio 2.1
% % ---------------
% fprintf(' ---------------\n')
% fprintf(' Esercizio 2.1\n')
% fprintf(' ---------------\n')
% pause
% 
% 
% Pw1=0.5;
% Pw2=0.5;
% 
% Mu1 = 3;%
% Mu2 = 0;%
% 
% sigma=1.5;
% 
% Sample_set1 =   normrnd(Mu1,sigma,num_s,1);
% Sample_set2 =   normrnd(Mu2,sigma,num_s,1);
% 
% Data = [Sample_set1 ; Sample_set2];
% 
% 
% % Disegno le funzioni discriminanti per la due classi di campioni Gaussiani
% 
% W1  = (1/sigma^2).*Mu1;
% w10 = -(1/(2*sigma^2))*(Mu1'*Mu1) +log(Pw1);
% G1 = sum(repmat(W1,1,num_s*2).*Data',1) + ones(1,num_s*2)*w10;
% 
% 
% W2  = (1/sigma^2).*Mu2;
% w20 = -(1/(2*sigma^2))*(Mu2'*Mu2) +log(Pw2);
% G2 = sum(repmat(W2,1,num_s*2).*Data',1) + ones(1,num_s*2)*w20;
% 
% % Confine di decisione
% W  = Mu1-Mu2;
% X0 = 0.5*(Mu1+Mu2)-((sigma^2)./((Mu1-Mu2)'*(Mu1-Mu2))).*log(Pw1/Pw2).*(Mu1-Mu2);
% 
% 
% h_CBayesG1D = figure; hold on;
% [Ord,index_ord] = sort(Data,'ascend');
% h_S1 = scatter(Sample_set1,zeros(num_s,1),10,'b');
% h_S2 = scatter(Sample_set2,zeros(num_s,1),10,'r');
% h_G1 = plot(Ord,G1(index_ord),'b');
% h_G2 = plot(Ord,G2(index_ord),'r');
% set(gcf,'name','Classificatore Bayesiano 2 classi 1D')
% h_BayesG1D=line([X0;X0],[min([G1';G2']),max([G1';G2'])],'color',[0,0,0]);
% %legend([h_G1;h_G2;h_BayesG1D],{'g_1(x)';'g_2(x)';'x_0'});
% legend([h_S1(1);h_S2(1);h_G1;h_G2],{strcat('N1: \mu1=',num2str(Mu1),' \sigma1=',num2str(sigma));...
%     strcat('N2: \mu2=',num2str(Mu2),' \sigma2=',num2str(sigma));...
%     'g_1(x)';'g_2(x)'});
% 
% pause
% 
% % ---------------
% % Esercizio 2.2
% % ---------------
% fprintf(' ---------------\n')
% fprintf(' Esercizio 2.2\n')
% fprintf(' ---------------\n')
% A=rgb2gray(imread('1.jpg'));
% A=A(1:4:end,1:4:end);
% rows = size(A,1);
% cols = size(A,2); 
% 
% figure; 
% set(gcf,'name','Medie e varianze, metodo veloce')
% colormap gray; subplot 221 ; imagesc(A); 
% title('Mean class 1');
% Mu1 = A(:);
% Sigma1 = ones(rows*cols,1).*10;
% subplot 222 ; imagesc(reshape(Sigma1,rows,cols)); colorbar; 
% title('Sigma class 1');
% 
% B=rgb2gray(imread('12.jpg'));
% B=B(1:4:end,1:4:end);
% subplot 223; imagesc(B); 
% title('Mean class 2');
% Mu2 = B(:);
% Sigma2 = ones(rows*cols,1).*10;
% subplot 224 ; imagesc(reshape(Sigma2,rows,cols)); colorbar; 
% title('Sigma class 2');
% 
% C1=[];
% C2=[];
% for i=1:12
%     test = rgb2gray(imread(strcat(num2str(i),'.jpg')));
%     test = test(1:4:end,1:4:end);
%     test=test(:);
%     LK1 = sum(log(normpdf(double(test),double(Mu1),double(Sigma1))));
%     LK2 = sum(log(normpdf(double(test),double(Mu2),double(Sigma2))));
%     if LK1 >LK2
%         C1 = [C1,i];
%     else
%         C2 = [C2,i];
%     end
% end
% latoC1=ceil(sqrt(length(C1)));
% latoC2=ceil(sqrt(length(C2)));
% figure;
% set(gcf,'name','Classe 1')
% count=1;
% for i=1:length(C1)
%     
%     subplot(latoC1,latoC1,i);
%     test = rgb2gray(imread(strcat(num2str(C1(i)),'.jpg')));
%     imagesc(test);axis off; colormap gray;
%     
% end
% 
% figure;
% set(gcf,'name','Classe 2')
% count=1;
% for i=1:length(C2)
%     
%     subplot(latoC2,latoC2,i);
%     test = rgb2gray(imread(strcat(num2str(C2(i)),'.jpg')));
%     imagesc(test);axis off; colormap gray;
%     
% end    
% 
% % ---------------
% % Esercizio 2.3
% % ---------------  
% fprintf('Premi un tasto per continuare!\n')
% pause
% 
% Vol1 = [];
% Vol2 = [];
% for i=1:5
%     test = rgb2gray(imread(strcat(num2str(i),'.jpg')));
%     test = test(1:4:end,1:4:end);
%     Vol1 = [Vol1,test(:)];
% end
% for i=8:9
%     test = rgb2gray(imread(strcat(num2str(i),'.jpg')));
%     test = test(1:4:end,1:4:end);
%     Vol2 = [Vol2,test(:)];
% end
% 
% 
% Eff_mean1 = mean(Vol1,2);
% Eff_sigma1 = std(single(Vol1)');
% Eff_mean2 = mean(Vol2,2);
% Eff_sigma2 = std(single(Vol2)');
% 
% h_Mean_Std = figure;
% set(gcf,'name','Medie e varianze, metodo robusto')
% colormap gray;
% subplot 221; imagesc(reshape(Eff_mean1,rows,cols)); title('Mean class 1'); 
% subplot 222; imagesc(reshape(Eff_mean2,rows,cols)); title('Mean class 2'); 
% subplot 223; imagesc(reshape(Eff_sigma1,rows,cols)); title('Std class 1'); colorbar
% subplot 224; imagesc(reshape(Eff_sigma2,rows,cols)); title('Std class 2'); colorbar
% 
% fprintf('Premi un tasto per continuare!\n')
% pause
% 
% C1=[];
% C2=[];
% for i=1:12
%     test = rgb2gray(imread(strcat(num2str(i),'.jpg')));
%     test = test(1:4:end,1:4:end);
%     test=test(:);
%     LK1 = sum(log(normpdf(double(test),double(Eff_mean1),double(Eff_sigma1'+eps))));
%     LK2 = sum(log(normpdf(double(test),double(Eff_mean2),double(Eff_sigma2'+eps))));
%     if LK1 >LK2
%         C1 = [C1,i];
%     else
%         C2 = [C2,i];
%     end
%     i
% end
% latoC1=ceil(sqrt(length(C1)));
% latoC2=ceil(sqrt(length(C2)));
% figure;
% set(gcf,'name','Classe 1, nuova stima della media')
% for i=1:length(C1)
%     
%     subplot(latoC1,latoC1,i);
%     test = rgb2gray(imread(strcat(num2str(C1(i)),'.jpg')));
%     imagesc(test);axis off; colormap gray;
%     
% end
% 
% 
% figure;
% set(gcf,'name','Classe 2, nuova stima della media')
% for i=1:length(C2)
%     
%     subplot(latoC2,latoC2,i);
%     test = rgb2gray(imread(strcat(num2str(C2(i)),'.jpg')));
%     imagesc(test);axis off; colormap gray;
%     
% end    
% 
% 
% pause
% 
% % ---------------
% % Esercizio 3
% % ---------------
% fprintf(' ---------------\n')
% fprintf(' Esercizio 3\n')
% fprintf(' ---------------\n')
% C_info = aviinfo('piramide.avi');
% C = rgb2gray(frame2im(aviread('piramide.avi',C_info.NumFrames)));
% figure; imagesc(C); colormap gray; axis off; set(gcf,'name','Sottrazione del background: stima grezza della scena');
% Mu_BG = double(C(:));
% sigma_BG = 16;
% figure; set(gcf,'name','Sottrazione del background');
% for t=1:C_info.NumFrames
%     test = rgb2gray(frame2im(aviread('piramide.avi',t)));
%     res  = test(:)<Mu_BG-3*sigma_BG | test(:)>Mu_BG+3*sigma_BG;
%     imagesc(reshape(res,C_info.Height,C_info.Width));
%     pause
% end
% 
% % Q: Come fare a rendere il classificatore piu' robusto?
% % A: studiare la callse di BG da piu' immagini;
% figure;
% % for t=1:10
% %     test = rgb2gray(frame2im(aviread('piramide.avi',C_info.NumFrames-10+t)));
% %     imagesc(reshape(test,C_info.Height,C_info.Width));
% %     res(C_info.NumFrames-10+t)=input('immagine pulita? 1=si 0=no');
% % end
% 
% % good_indeces = find(res>0);
% 
% 
% i=0;
% for t=C_info.NumFrames-10:C_info.NumFrames
%     i=i+1; 
%     trainBG(:,:,i) = rgb2gray(frame2im(aviread('piramide.avi',t)));
% end
% 
% NewMean = mean(double(trainBG),3);
% NewStd  = std(double(trainBG),0,3);
% 
% figure; set(gcf,'name','Studio classe BG da immagini di training')
% subplot(121); imagesc(NewMean); colorbar; colormap gray;axis image
% subplot(122); imagesc(NewStd); colorbar; axis image
% 
% 
% %provate a calcolare la sottrazione del BG con le nuove stime dei
% %parametri;
% %Nella classificazione finale mixo i res ottenuti dal training
% % con un valore di confidenza che mi risolve il fatto di aver 
% % fatto learning su pochi dati.
% 
% for t=1:C_info.NumFrames
%     test = rgb2gray(frame2im(aviread('piramide.avi',t)));
%     res  = test(:)<NewMean(:)-3*(NewStd(:)+3) | test(:)>NewMean(:)+3*(NewStd(:)+3);
%     imagesc(reshape(res,C_info.Height,C_info.Width));
%     pause
% end
